unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, DB, DBTables, ComCtrls,
  StdCtrls, Mask, Menus;

type
  TfrmMain = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Table2: TTable;
    DataSource2: TDataSource;
    Table3: TTable;
    DataSource3: TDataSource;
    Splitter1: TSplitter;
    DBGrid3: TDBGrid;
    DBGrid2: TDBGrid;
    DBGrid1: TDBGrid;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    DBNavigator1: TDBNavigator;
    PopupMenu2: TPopupMenu;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    DBNavigator2: TDBNavigator;
    PopupMenu3: TPopupMenu;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    DBNavigator3: TDBNavigator;
    procedure N2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DBGrid2DblClick(Sender: TObject);
    procedure DBGrid3DblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses EditName, EditPhone, EditAdress, IniFiles;
var  Ini: TIniFile;
     IniFileName: string;

{$R *.dfm}

procedure TfrmMain.N2Click(Sender: TObject);
begin
Table1.CachedUpdates := true;
Table1.Edit;
frmNameEdit := TfrmNameEdit.Create(Self);
  if frmNameEdit.ShowModal = mrOK then
    begin
      Table1.Post;
      Table1.ApplyUpdates
    end
  else
    begin
      Table1.Cancel;
      Table1.CancelUpdates
    end;
    Table1.CachedUpdates := False;
    frmNameEdit.Free;
end;

procedure TfrmMain.N1Click(Sender: TObject);
begin
DBNavigator1.BtnClick(nbInsert);
Table1.CachedUpdates := true;
Table1.Insert;
frmNameEdit := TfrmNameEdit.Create(Self);
  if frmNameEdit.ShowModal = mrOK then
    begin
      Table1.Post;
      Table1.ApplyUpdates
    end
  else
    begin
      Table1.Cancel;
      Table1.CancelUpdates
    end;
    Table1.CachedUpdates := False;
    frmNameEdit.Free;
end;

procedure TfrmMain.DBGrid1DblClick(Sender: TObject);
begin
n2.Click();
end;

procedure TfrmMain.N3Click(Sender: TObject);
begin
case Application.MessageBox('     ?',
                                                '', MB_YESNO) of
6: DBNavigator1.BtnClick(nbDelete); end;
end;

procedure TfrmMain.N5Click(Sender: TObject);
begin
Table1.CachedUpdates := true;
Table1.Edit;
frmPhoneEdit := TfrmPhoneEdit.Create(Self);
  if frmPhoneEdit.ShowModal = mrOK then
    begin
      Table1.Post;
      Table1.ApplyUpdates
    end
  else
    begin
      Table1.Cancel;
      Table1.CancelUpdates
    end;
    Table1.CachedUpdates := False;
    frmPhoneEdit.Free;
end;

procedure TfrmMain.N4Click(Sender: TObject);
begin
DBNavigator2.BtnClick(nbInsert);
Table2.CachedUpdates := true;
Table2.Insert;
frmPhoneEdit := TfrmPhoneEdit.Create(Self);
  if frmPhoneEdit.ShowModal = mrOK then
    begin
      Table2.Post;
      Table2.ApplyUpdates
    end
  else
    begin
      Table2.Cancel;
      Table2.CancelUpdates
    end;
    Table2.CachedUpdates := False;
    frmPhoneEdit.Free;
end;

procedure TfrmMain.N6Click(Sender: TObject);
begin
case Application.MessageBox('     ?',
                                                '', MB_YESNO) of
6: DBNavigator2.BtnClick(nbDelete); end;
end;

procedure TfrmMain.N7Click(Sender: TObject);
begin
DBNavigator3.BtnClick(nbInsert);
Table3.CachedUpdates := true;
Table3.Insert;
frmAdressEdit := TfrmAdressEdit.Create(Self);
  if frmAdressEdit.ShowModal = mrOK then
    begin
      Table3.Post;
      Table3.ApplyUpdates
    end
  else
    begin
      Table3.Cancel;
      Table3.CancelUpdates
    end;
    Table3.CachedUpdates := False;
    frmAdressEdit.Free;
end;

procedure TfrmMain.N8Click(Sender: TObject);
begin
Table3.CachedUpdates := true;
Table3.Edit;
frmAdressEdit := TfrmAdressEdit.Create(Self);
  if frmAdressEdit.ShowModal = mrOK then
    begin
      Table3.Post;
      Table3.ApplyUpdates
    end
  else
    begin
      Table3.Cancel;
      Table3.CancelUpdates
    end;
    Table3.CachedUpdates := False;
    frmAdressEdit.Free;
end;

procedure TfrmMain.N9Click(Sender: TObject);
begin
case Application.MessageBox('     ?',
                                                '', MB_YESNO) of
6: DBNavigator3.BtnClick(nbDelete); end;
end;

procedure TfrmMain.DBGrid1TitleClick(Column: TColumn);
begin
if Column = DBGrid1.Columns.Items[0] then Table1.IndexName := 'indSurName';
if Column = DBGrid1.Columns.Items[1] then Table1.IndexName := 'indName';
if Column = DBGrid1.Columns.Items[2] then Table1.IndexName := 'indOther';
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
try
    Table1.Close;
    Table2.Close;
    Table3.Close;
    Table1.DatabaseName := ExtractFilePath(Application.ExeName) + 'Data';
    Table2.DatabaseName := ExtractFilePath(Application.ExeName) + 'Data';
    Table3.DatabaseName := ExtractFilePath(Application.ExeName) + 'Data';
    Table1.TableName := 'person';
    Table2.TableName := 'telephone';
    Table3.TableName := 'adress';
    Table1.Open;
    Table2.Open;
    Table3.Open;
  except
    on E:EDatabaseError do
      begin
      Application.MessageBox(PChar('Could not open Table'+#13+E.Message), 'Open Error', MB_ICONERROR);
      Halt;
      end;
  end;

//INI File
IniFileName := ChangeFileExt(Application.ExeName,'.ini');
Ini := TIniFile.Create(IniFileName);
  DBGrid1.Columns[0].Width := Ini.ReadInteger('View', 'NameWidth', 130);
  DBGrid1.Columns[1].Width := Ini.ReadInteger('View', 'SurNameWidth', 180);
  DBGrid1.Columns[2].Width := Ini.ReadInteger('View', 'OtherWidth', 280);
    DBGrid2.Columns[0].Width := Ini.ReadInteger('View', 'PhoneNumberWidth', 125);
    DBGrid2.Columns[1].Width := Ini.ReadInteger('View', 'PhoneTypeWidth', 80);
      DBGrid3.Columns[0].Width := Ini.ReadInteger('View', 'AdressWidth', 295);
      DBGrid3.Columns[1].Width := Ini.ReadInteger('View', 'AdressTypeWidth', 65);
        Table1.IndexName := Ini.ReadString('View', 'SortBy', 'indName');
Ini.Destroy;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Ini := TIniFile.Create(IniFileName);
  Ini.WriteInteger('View', 'NameWidth', DBGrid1.Columns[0].Width);
  Ini.WriteInteger('View', 'SurNameWidth', DBGrid1.Columns[1].Width);
  Ini.WriteInteger('View', 'OtherWidth', DBGrid1.Columns[2].Width);
    Ini.WriteInteger('View', 'PhoneNumberWidth', DBGrid2.Columns[0].Width);
    Ini.WriteInteger('View', 'PhoneTypeWidth', DBGrid2.Columns[1].Width);
      Ini.WriteInteger('View', 'AdressWidth', DBGrid3.Columns[0].Width);
      Ini.WriteInteger('View', 'AdressTypeWidth', DBGrid3.Columns[1].Width);
        Ini.WriteString('View', 'SortBy', Table1.IndexName);
Ini.Destroy;
end;

procedure TfrmMain.DBGrid2DblClick(Sender: TObject);
begin
n5.Click();
end;

procedure TfrmMain.DBGrid3DblClick(Sender: TObject);
begin
n8.Click();
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
DBNavigator1.BtnClick(nbFirst);
end;

end.
